#include <add-ons/input_server/InputServerFilter.h>
#include "vmw_door.h"


class TVMWMouseFilter : public BInputServerFilter
{
public:
	TVMWMouseFilter() : BInputServerFilter() {};
	~TVMWMouseFilter() {};
	status_t InitCheck() { return B_OK; };
	filter_result Filter(BMessage *msg, BList* outList) {
		int p, x, y;
		switch(msg->what) {
			case B_MOUSE_MOVED:
				if (vmw_get_options() & VMW_OPT_FULLSCREEN) break;
				p = vmw_get_mouse_pos();
				x = p >> 16;
				y = p & 0xffff;
				if ((x < 0) || (y < 0)) break;
				msg->RemoveName("where");
				msg->AddPoint("where", BPoint(x, y));
				break;
		}
		return B_DISPATCH_MESSAGE;
	};
};

extern "C" _EXPORT BInputServerFilter* instantiate_input_filter()
{
	return new TVMWMouseFilter();
}
